#!/usr/bin/perl -w

use strict;
require 'pltests.pl';

#my @TESTS = (
#    'mknmz-1.pl', 'mknmz-2.pl', 'mknmz-3.pl', 'mknmz-4.pl', 
#    'gcnmz-1.pl',
#    'mknmz-5.pl', 'mknmz-6.pl', 'mknmz-7.pl',
#    'mknmz-14.pl',
#    'idxdiff-1.pl', 'idxdiff-2.pl', 'idxdiff-3.pl',
#    'namazu-1.pl', 'namazu-2.pl', 'namazu-3.pl', 'namazu-4.pl',
#    'namazu-7.pl', 'namazu-9.pl', 
#    'namazu-10.pl', 'namazu-11.pl', 'namazu-12.pl',
#    'namazu-cgi-1.pl', 'namazu-cgi-2.pl',
#);
my @TESTS = (
    'mknmz-1.pl', 'mknmz-2.pl', 'mknmz-4.pl', 
    'gcnmz-1.pl',
    'mknmz-5.pl', 'mknmz-6.pl', 'mknmz-7.pl',
    'mknmz-14.pl',
    'idxdiff-1.pl', 'idxdiff-3.pl',
    'namazu-1.pl', 'namazu-2.pl', 'namazu-3.pl', 'namazu-4.pl',
    'namazu-7.pl', 'namazu-9.pl', 
    'namazu-10.pl', 'namazu-11.pl', 'namazu-12.pl',
    'namazu-cgi-1.pl', 'namazu-cgi-2.pl',
);
my @XFAIL_TESTS = ();

print "  *** starting $0\n";

my $failed = 0;
my $xpass = 0;
my $xfail = 0;
my $all = 0;
for my $test (@TESTS) {
    my $cmd = pltests::localpath("./$test");
    system("perl $cmd");
    if ($? == 0) {
        my $xfail_test = 0;
        for my $fail_test (@XFAIL_TESTS) {
            if ($fail_test eq $test) {
                $xfail_test = 1;
            }
        }

        $all++;
        if ($xfail_test == 1) {
            $xpass++;
            $failed++;
            print "XPASS: $test\n";
        } else {
            print "PASS: $test\n";
        }
    } elsif ($? != 77) {
        my $xfail_test = 0;
        for my $fail_test (@XFAIL_TESTS) {
            if ($fail_test eq $test) {
                $xfail_test = 1;
            }
        }

        $all++;
        if ($xfail_test == 1) {
            $xfail++;
            print "XFAIL: $test\n";
        } else {
            $failed++;
            print "FAIL: $test\n";
        }
    }
}

my $banner;
if ($failed == 0) {
    if ($xfail == 0) {
        $banner = "All $all tests passed";
    } else {
        $banner = "All $all tests behaved as expected ($xfail expected failures)";
    }
} else {
    if ($xpass == 0) {
        $banner = "$failed of $all tests failed";
    } else {
        $banner = "$failed of $all tests did not behave as expected ($xpass unexpected passes)";
    }
}

my $dash = $banner;
$dash =~ s/./=/g;
print "$dash\n";
print "$banner\n";
print "$dash\n";

exit ($failed != 0);
