#!/usr/bin/perl -w
#
# Test for incremental indexing.
#

use strict;
require Cwd;
require 'pltests.pl';

my $cwd = Cwd::getcwd();
my $LOG = "$cwd/test-log";
my $TARGET;
my $INDEX = "$cwd/idx2";
my $INDEX1 = "$cwd/idx1";
my $MKNMZ = pltests::binpath('mknmz');

my $cmd;

pltests::putline($LOG, "  *** starting $0");

if (-d "$INDEX") {
    unlink(<$INDEX/NMZ.*>);
} else {
    mkdir("$INDEX");
}

$TARGET = pltests::cat("$INDEX1/NMZ.field.uri");
unless (defined $TARGET) {
    exit 1;
}
$TARGET =~ s!^/([A-Z])\|!$1:!mig;
$TARGET =~ tr/\n\r/  /;

# Simple indexing.
$cmd = "$MKNMZ --no-delete -O $INDEX $TARGET";
pltests::putline($LOG, "  $cmd");
system("$cmd >> $LOG");

exit $?;
