#!/usr/bin/perl -w
#
# Test for indexing with --checkpoint and $ON_MEMORY_MAX is 0.
#

use strict;
require Cwd;
require 'pltest.pl';

my $cwd = Cwd::getcwd();
my $LOG = "$cwd/test-log";
my $TARGET = pltest::selectdata();
my $INDEX = "$cwd/idx3";
my $MKNMZ = "mknmz";

my $cmd;

pltest::putline($LOG, "  *** starting $0");

if (-d "$INDEX") {
    unlink(<$INDEX/NMZ.*>);
} else {
    mkdir("$INDEX");
}

my $tmprc = "$cwd/mknmzrc";
pltest::putline($tmprc, '$conf::ON_MEMORY_MAX=0');

# Simple indexing.
$cmd = "$MKNMZ --checkpoint -f $tmprc -O $INDEX $TARGET";
pltest::putline($LOG, "  $cmd");
system("$cmd >> $LOG");
my $status = $?;

if (-f $tmprc) {
    unlink $tmprc;
}

exit $status;
