#!/usr/bin/perl -w
#
# Make an index for testing query operations.
#

use strict;
require Cwd;
require 'pltests.pl';

my $cwd = Cwd::getcwd();
my $LOG = "$cwd/test-log";
my $TARGET = "$cwd/../tests/data/query";
my $INDEX = "$cwd/idx8";
my $MKNMZ = pltests::binpath('mknmz');

my $cmd;

pltests::putline($LOG, "  *** starting $0");

if (-d "$INDEX") {
    unlink(<$INDEX/NMZ.*>);
} else {
    mkdir("$INDEX");
}

# Simple indexing.
$cmd = "$MKNMZ -O $INDEX $TARGET";
pltests::putline($LOG, "  $cmd");
system("$cmd >> $LOG");

exit $?;
