#!/usr/bin/perl -w
#
# Test for mknmz's --html-split option.
#

use strict;
require Cwd;
require 'pltests.pl';

my $cwd = Cwd::getcwd();
my $LOG = "$cwd/test-log";
my $TARGET = "$cwd/../tests/data/html-split";
my $INDEX = "$cwd/idx9";
my $MKNMZ = pltests::binpath('mknmz');

my $cmd;

pltests::putline($LOG, "  *** starting $0");

if (-d "$INDEX") {
    unlink(<$INDEX/NMZ.*>);
} else {
    mkdir("$INDEX");
}

# Indexing with --html-split option.
$cmd = "$MKNMZ --html-split -O $INDEX $TARGET";
pltests::putline($LOG, "  $cmd");
system("$cmd >> $LOG");

exit $?;
