#!/usr/bin/perl -w
#
# Test for namazu. Two indices are searched at once.
#

use strict;
require Cwd;
require 'pltests.pl';

my $cwd = Cwd::getcwd();
my $LOG = "$cwd/test-log";
my $INDEX = "$cwd/idx1";
my $INDEX2 = "$cwd/idx2";
my $NAMAZU = pltests::binpath('namazu');

my $cmd;

pltests::putline($LOG, "  *** starting $0");

my $docnum;
my $doc = pltests::cat("$INDEX/NMZ.status");
unless (defined $doc) {
    exit 1;
}
if ($doc =~ /^files (\d+)/m) {
    $docnum = $1;
} else {
    exit 1;
}
$docnum = $docnum + $docnum;

# Check simple searching.
$cmd = "$NAMAZU namazu $INDEX $INDEX2";
pltests::putline($LOG, "  $cmd");
system("$cmd >> $LOG");
if ($? != 0) {
    exit 1;
}

# Check the number of retrieved documents.
$cmd = "$NAMAZU -c namazu $INDEX $INDEX2";
my $hitnum = `$cmd`;
chomp $hitnum;
unless (defined $hitnum) {
    exit 1;
}

pltests::putline($LOG, "docnum: $docnum hitnum: $hitnum");

if ($docnum != $hitnum) {
    exit 1;
}

exit 0;
