#!/usr/bin/perl -w
#
# Test for namazu.cgi.
#

use strict;
require Cwd;
require 'pltests.pl';

my $cwd = Cwd::getcwd();
my $LOG = "$cwd/test-log";
my $INDEX = "$cwd/idx1";
my $NAMAZU = pltests::binpath('namazu.cgi');
my $RC = pltests::binpath('.namazurc');

my $cmd;

$ENV{'SCRIPT_NAME'} = 'namazu.cgi';
$ENV{'QUERY_STRING'} = 'query=namazu&idxname=idx1';

pltests::putline($LOG, "  *** starting $0");

my $docnum;
my $doc = pltests::cat("$INDEX/NMZ.status");
unless (defined $doc) {
    exit 1;
}
if ($doc =~ /^files (\d+)/m) {
    $docnum = $1;
} else {
    exit 1;
}

if (-f $RC) {
    unlink("$RC");
}
pltests::putline($RC, "Index $cwd");
pltests::duprcs($RC);

# Check simple searching.
$cmd = "$NAMAZU";
my $result = `$cmd`;
unless (defined $result) {
    exit 1;
}

my $hitnum = undef;
if ($result =~ /<!-- HIT -->(\d+)<!-- HIT -->/) {
    $hitnum = $1;
}
unless (defined $hitnum) {
    exit 1;
}

pltests::putline($LOG, "docnum: $docnum hitnum: $hitnum");

if ($docnum != $hitnum) {
    exit 1;
}

exit 0;

END {
    if (-f $RC) {
#        unlink("$RC");
    }
}
