#
# -*- Perl -*-
# $Id:$
# Copyright (C) 2004 Tadamasa Teranishi All rights reserved.
# Copyright (C) 2000-2004 Namazu Project All rights reserved.
#     This is free software with ABSOLUTELY NO WARRANTY.
#

package pltests;
use strict;
require Cwd;
use IO::File;
use File::Basename;
use File::Copy;

my $SYSTEM = $^O;

sub selectdata() {
    my $cwd = Cwd::getcwd();
    my $base = "$cwd/../tests/data";
    my @lang = ("LC_ALL", "LC_CTYPE", "LANG");
  
    for my $lang (@lang) {
        $lang = $ENV{$lang};
        if (defined $lang) {
            if ($lang =~ /^(..)/) {
                my $dir = "$base/$1";
                if (-d "$dir") {
                    return $dir;
                }
            }
        }
    }

    return "$base/en";
}

sub putline($$) {
    my ($file, $msg) = @_;

    if (!open(OUT, ">> $file")) {
        warn "Can not open file : $file";
        return '';
    }
    my $oldfh = select(OUT); $| = 1; select($oldfh);

    print OUT "$msg\n";
    close(OUT);

    return 1;
}

sub cat($) {
    my ($file) = @_;

    my $data = '';

    if (!open(IN, "$file")) {
        warn "Can not open file : $file\n";
        return undef;
    }
    while(my $line = <IN>) {
        $data .= $line;
    }
    close(IN);

    return $data;
}

sub localpath($) {
    my ($path) = @_;

    $path =~ s!/!\\!g if (($SYSTEM eq "MSWin32") || ($SYSTEM eq "os2"));

    return $path;
}

sub binpath($) {
    my ($cmd) = @_;
    my $path = undef;

    if ($SYSTEM eq "MSWin32") {
        if ($cmd =~ /namazu.cgi/) {
            $path = "../libexec/$cmd";
        } elsif ($cmd =~ /.namazurc/) {
            $path = "../libexec/$cmd";
        } else {
            $path = "../bin/$cmd";
        }
    } else {
        if ($cmd =~ /(?:mknmz|gcnmz)/) {
            $path = "../scripts/$cmd";
        } else {
            if (-x "../src/.libs/$cmd") {
                $path = "../src/.libs/$cmd";
            } elsif (-x "../src/_libs/$cmd") {
                $path = "../src/_libs/$cmd";
            } else {
                $path = "../src/$cmd";
            }
        }
    }

    return localpath($path);
}

sub duprcs($) {
    my ($rc) = @_;

    if ($SYSTEM eq "MSWin32") {
        ;
    } else {
        if (-d "../src/.libs") {
            copy($rc, "../src/.libs");
        }
        if (-d "../src/_libs") {
            copy($rc, "../src/_libs");
        }
    }
}

1;
